import { AfterViewInit, ElementRef, EventEmitter } from '@angular/core';
import { SafeHtml } from '@angular/platform-browser';
import { Subject } from 'rxjs';
import { Color } from './components/text-color/text-color.component';
import { Link } from './components/edit-link/Link';
import { EditorApi } from './angular-universal-editor-api';
import { EditorConfig } from './angular-universal-editor-config';
import { MentionUser } from './angular-universal-editor-mention-user';
import * as i0 from "@angular/core";
export declare class AngularUniversalEditorComponent implements AfterViewInit {
    config: EditorConfig;
    mentionUsers: MentionUser[];
    onChange: EventEmitter<string>;
    onEditorReady: EventEmitter<EditorApi>;
    onChangeMentionUsers: EventEmitter<MentionUser[]>;
    onFilesChanged: EventEmitter<{
        file: File;
        key: string;
    }[]>;
    editor: ElementRef;
    private widthSubject;
    editorWidth$: import("rxjs").Observable<number>;
    editorWidth: number;
    editorWidthM: number;
    editorWidthS: number;
    textColors: {
        colorName: string;
        colorCode: string;
        selected: boolean;
    }[];
    darkMode: boolean;
    defaultTextColor: Color | undefined;
    innerHtml: SafeHtml;
    private el;
    private sanitizer;
    ngAfterViewInit(): void;
    onKeydown(event: KeyboardEvent): void;
    onInput(event: any): void;
    handlePaste(event: ClipboardEvent): void;
    private textElement;
    private selectedText;
    resizeTimeout: any;
    private editorHTML;
    private taggedUsers;
    private savedRange;
    private savedChanges;
    private emitChange;
    triggerInnerHtml(html: string | SafeHtml): void;
    private removeClassess;
    private mergeAdjacent;
    private splitAtCaret;
    private splitElementAtText;
    private replaceElement;
    private deleteCharBeforeCaret;
    private createElementFromString;
    private addElement;
    private setCursorPositionAfter;
    saveCaretPosition(): void;
    restoreCaretPosition(): void;
    onHostClick(event: MouseEvent): void;
    onResize(): void;
    onFormat(format: string): void;
    onOptions(option: string): void;
    private checkWatermark;
    private traverseTheDOM;
    currentDateElement: HTMLElement | undefined;
    dateSubject: Subject<Date>;
    currentDate$: import("rxjs").Observable<Date>;
    get dateDisabled(): boolean;
    addDate(): void;
    showDatePopup(show: boolean): void;
    onSelectDate(date: Date): void;
    currentTableElement: HTMLElement | undefined;
    currentCellElement: HTMLElement | undefined;
    newRow: HTMLElement | undefined;
    newColumn: HTMLElement[];
    get tableDisabled(): boolean;
    addTable(): void;
    showTablePopup(show: boolean): void;
    private setCursorInsideTable;
    removeTable(): void;
    clearCell(): void;
    onRemoveCellEnter(): void;
    onRemoveCellLeave(): void;
    removeRow(): void;
    onRemoveRowEnter(): void;
    onRemoveRowLeave(): void;
    removeColumn(): void;
    onRemoveColumnEnter(): void;
    onRemoveColumnLeave(): void;
    insertRow(): void;
    onInsertRowEnter(): void;
    onInsertRowLeave(): void;
    insertColumn(): void;
    onInsertColumnEnter(): void;
    onInsertColumnLeave(): void;
    private addRemoveTableClass;
    onRemoveTableEnter(): void;
    onRemoveTableLeave(): void;
    currentCodeElement: HTMLElement | undefined;
    isExpandedCode: boolean;
    get codeDisabled(): boolean;
    addCode(codeText: string): void;
    removeCode(): void;
    copyCode(): void;
    private updateNumberOfLines;
    showCodePopup(show: boolean): void;
    private addRemoveCodeClass;
    expandCollapseCode(show: boolean): void;
    onRemoveCodeEnter(): void;
    onRemoveCodeLeave(): void;
    files: {
        file: File;
        key: string;
    }[];
    currentImageElement: HTMLElement | undefined;
    private resizing;
    private startX;
    private startWidth;
    private maxWidth;
    altText: string;
    private altTextSubject;
    altText$: import("rxjs").Observable<void>;
    get fileDisabled(): boolean;
    private setImageUrl;
    showAddEditAltText(show: boolean): void;
    onSubmitAltText(altText: string): void;
    private addImage;
    private addFile;
    removeFile(key?: string): void;
    copyImage(): Promise<void>;
    uploadFile(): void;
    private addSizerIntoImageWrapper;
    private showImgPopup;
    private clearSizer;
    resizeImage(event: MouseEvent): void;
    onRemoveImgEnter(): void;
    onRemoveImgLeave(): void;
    setUploadFiles(files: {
        file: File;
        key: string;
    }[]): void;
    isBulletList: boolean;
    private currentBulletListElement;
    get bulletListDisabled(): boolean;
    onBulletListClick(): void;
    isNumberedList: boolean;
    private currentNumberedListElement;
    get numberedListDisabled(): boolean;
    onNumberedListClick(): void;
    private textStyles;
    textStyle: string;
    private currentTextStyleElement;
    get textStyleDisabled(): boolean;
    onStyleChange(event: string): void;
    selectedColor: Color | undefined;
    private currentTextColorElement;
    private textColorRef;
    get textColorDisabled(): boolean;
    private setDefaultTextColor;
    triggerTextColor(color: 'Black' | 'Gainsboro' | 'Red' | 'Green' | 'Blue' | 'Yellow' | 'Cyan' | 'Magenta' | 'Light Gray' | 'Gray' | 'Maroon' | 'Olive' | 'Purple' | 'Teal' | 'Navy' | 'Coral' | 'Turquoise' | 'Salmon' | 'Lime' | 'Gold' | 'Orchid'): {
        colorName: string;
        colorCode: string;
        selected: boolean;
    };
    onTextColorChange(color: Color): void;
    isBold: boolean;
    private currentBoldElement;
    get boldDisabled(): boolean;
    onSelectBold(): void;
    isItalic: boolean;
    private currentItalicElement;
    get italicDisabled(): boolean;
    onSelectItalic(): void;
    isUnderline: boolean;
    private currentUnderlineElement;
    get underlineDisabled(): boolean;
    onSelectUnderline(): void;
    isStrikethrough: boolean;
    private currentStrikethroughElement;
    get strikethroughDisabled(): boolean;
    onSelectStrikethrough(): void;
    isSubscript: boolean;
    private currentSubscriptElement;
    get subscriptDisabled(): boolean;
    onSelectSubscript(): void;
    isSuperscript: boolean;
    private currentSupesrsciptElement;
    get superscriptDisabled(): boolean;
    onSelectSuperscript(): void;
    private highestFormatElement;
    get clearFormattingDisabled(): boolean;
    onClearFormatting(): void;
    private linkSubject;
    link$: import("rxjs").Observable<void>;
    linkData: Link | undefined;
    linkMode: 'Add' | 'Edit';
    private isAddEditLinkDialogOpen;
    copySelected: boolean;
    private currentLinkElement;
    get linkDisabled(): boolean;
    private showLinkPopup;
    showAddEditLink(show: boolean, mode: 'Add' | 'Edit'): void;
    openLink(): void;
    unLink(): void;
    copyLink(): void;
    removeLink(): void;
    private addLink;
    onSubmitLink(link: Link): void;
    onRemoveLinkEnter(): void;
    onRemoveLinkLeave(): void;
    triggerLink(): void;
    private isMentionDropdownOpen;
    filteredUsers: any[];
    private searchUserText;
    private enteredUser;
    get mentionDisabled(): boolean;
    onMentionClick(): void;
    onMouseEnter(enteredUser: any): void;
    onSelectUser(user: any): void;
    private onCancelSelectUser;
    private getCaretCoordinates;
    private openMentionDropdown;
    private closeMentionDropdown;
    private filterUsers;
    private setCurrentUserClass;
    static ɵfac: i0.ɵɵFactoryDeclaration<AngularUniversalEditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AngularUniversalEditorComponent, "angular-universal-editor", never, { "config": { "alias": "config"; "required": false; }; "mentionUsers": { "alias": "mentionUsers"; "required": false; }; }, { "onChange": "onChange"; "onEditorReady": "onEditorReady"; "onChangeMentionUsers": "onChangeMentionUsers"; "onFilesChanged": "onFilesChanged"; }, never, never, false, never>;
}
